#dsk2zip.py
#
#MSXエミュレータ用のdskイメージからファイルを取り出して
#zipファイルを作成します。
#makeflo.pyが必要です。
#https://github.com/bbbradsmith/makeflop.py
#iOS用のPythonista3でMSXエミュレータを使用する際に役立ちます

#以下のファイル名を書き換えてください。

dskfilename = "TEST.dsk"

from datetime import datetime
import makeflop
import os
import zipfile
import re

nowtime = datetime.now()

dirname = './tmp_' + nowtime.strftime('%Y%m%d_%H%M%S')

os.makedirs(dirname)

zipfilename = re.match("[A-Za-z0-9¥_¥-¥(¥)¥+]+" , dskfilename).group() + ".zip"

f = makeflop.Floppy.open(dskfilename)

filelist = [f.files_info().split('\n')]

f.extract_all(dirname)

for contentfilename in filelist[0] :
	if contentfilename is not '' :
		print(dirname + '/' + contentfilename)
		
		with zipfile.ZipFile(zipfilename, 'a') as fmyzip:

			fmyzip.write(dirname + '/' + contentfilename, contentfilename )
			
			os.remove(dirname + '/' + contentfilename)
			
os.rmdir(dirname)

